
def load_sites(filename):
    f  = open(filename)
    pre_sites=[]
    post_sites=[]

    for row in f:
        if row[0] == '>':
            continue
        pre_sites.append(row[:7])
        post_sites.append(row[7:])

    f.close()
    return pre_sites,post_sites

def compute_post_site_patterns(sites, maxlen):
    
    patterns={}

    for site in sites:
        for k in range(2,maxlen):
            pattern = site[:k]
            if not patterns.has_key(pattern):
                patterns[pattern]=1
            else:
                patterns[pattern]+=1

    return patterns

def compute_pre_site_patterns(sites, maxlen):
    
    patterns={}

    for site in sites:
        for k in range(2,maxlen+1):
            pattern = site[-k:]
            if not patterns.has_key(pattern):
                patterns[pattern]=1
            else:
                patterns[pattern]+=1

    return patterns


def filter_by_freq(freqs, threshold):
    filtered_freqs={}

    for (k,v) in freqs.items():
        if v >= threshold:
            filtered_freqs[k]=v
    
    return filtered_freqs
 
def splice_patterns(filename, threshold):
    pre_sites,post_sites = load_sites(filename)
    print filter_by_freq(compute_pre_site_patterns(pre_sites, 7), threshold)
    print filter_by_freq(compute_post_site_patterns(post_sites, 8), threshold)

filename=raw_input("Nome file: ")
threshold=int(raw_input("Soglia: "))

splice_patterns(filename, threshold)
