
def load_data(filename):

    f=open(filename)
    rbps={}

    for row in f.readlines()[1:]:
        data=row.split("\t")
        go_id=data[0]
        go_term=data[1]
        rbp=data[11]
        if not rbps.has_key(rbp):
            rbps[rbp]={}
        rbps[rbp][go_id]=go_term

    f.close()
    return rbps

def set_intersection(data1, data2):
    
    set_inter = {}

    for (rbp,goterms) in data1.items():
        if not data2.has_key(rbp):
            set_inter[rbp] = goterms
            continue
        set_inter[rbp] = {}
        goterms2 = data2[rbp]
        for go_id,go_term in goterms.items():
            if goterms2.has_key(go_id):
                set_inter[rbp][go_id] = go_term

    return set_inter

def filter_by_size(data, thres):

    newdata={}

    for (key,val) in data.items():
        if len(val) >= thres:
            newdata[key] = val
            
    return newdata
    

def print_enrichment(data):
    
    for (rbp,goterms) in data.items():
        print "RBP:\t" + rbp
        print "GOTERMS:\t" + ",".join(["%s (%s)" % (go_id,go_term) for (go_id,go_term) in goterms.items()])

def enrichment(file1,file2,threshold):

    data1 = load_data(file1)
    data2 = load_data(file2)

    data1_and_2 = set_intersection(data1, data2)
    data1_and_2_filtered = filter_by_size(data1_and_2, threshold)

    print_enrichment(data1_and_2_filtered)


file1=raw_input("Inserire primo file di enrichment: ")
file2=raw_input("Inserire secondo file di enrichment: ")
thres=int(raw_input("Inserire soglia: "))

enrichment(file1,file2,thres)
