
def load_data(filename):
    
    f=open(filename)
    pfams={}

    full_header=f.readline().strip().split("\t")

    for row in f.readlines():
        data = row.strip().split("\t")
        pfams[data[0]] = data[3:]

    f.close()
    return pfams,full_header[0:1]+full_header[3:]


def select_families(pfams, pattern):
    
    selection={}

    for pfam,data in pfams.items():
        if data[-1].lower().find(pattern) > -1:
            selection[pfam] = data
    
    return selection



def compute_stats(pfams):
    stats = [0.,0.,0.,0.,0.]

    for pfam,data in pfams.items():
        for i in range(len(stats)):
            stats[i]+=float(data[i])
        
    for i in range(len(stats)):
        stats[i] /= len(pfams)

    return stats
            

def print_stats(pfams, stats, header):
    print "\t".join(header)
    
    for pfam,data in pfams.items():
        print pfam + "\t" + "\t".join(data)

    print "AVG\t" + "\t".join(["%.2f" %s for s in stats]) + "\taverage"


def pfam_statistics(filename, pattern):

    pfams,header = load_data(filename)
    selection = select_families(pfams, pattern)
    stats = compute_stats(selection)
    print_stats(selection, stats, header)


filename=raw_input("Inserire nome file: ")
pattern=raw_input("Inserire pattern da cercare: ")

pfam_statistics(filename, pattern)
